Bug 1197881 - Roll up 3 has broken FSW. Only the most recent REST application will function correctly.
Summary: Roll up 3 has broken FSW. Only the most recent REST application will functio...
Keywords:
Status: ON_QA
Alias: None
Product: JBoss Fuse Service Works 6
Classification: JBoss
Component: SwitchYard
Version: 6.0.0 GA
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: CR1
: ---
Assignee: Aileen
QA Contact: Matej Melko
URL:
Whiteboard:
Depends On:
Blocks: 1183067 1241859
TreeView+ depends on / blocked
 
Reported: 2015-03-02 21:09 UTC by Rick Wagner
Modified: 2019-08-15 04:19 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Support Patch


Attachments (Terms of Use)
Test App 1. (19.74 KB, application/x-gzip)
2015-03-02 21:26 UTC, Rick Wagner
no flags Details
Test App 2. (20.09 KB, application/x-gzip)
2015-03-02 21:27 UTC, Rick Wagner
no flags Details


Links
System ID Priority Status Summary Last Updated
Red Hat Issue Tracker SWITCHYARD-2605 Major Resolved Remove commit of 2124 2018-01-31 07:50:02 UTC
Red Hat Issue Tracker SWITCHYARD-2610 Major Resolved Remove commit of 2124 2018-01-31 07:50:02 UTC

Description Rick Wagner 2015-03-02 21:09:31 UTC
Roll up patch FSW_6.0_3_2014 seems to have broken REST.

Tha attached applications can be deployed to FSW 6.0GA, then tested with a browser:

http://localhost:8080/icc/test/aaa/dummy    // checks application 1
http://localhost:8080/icc/test/bbb/dummy    // checks application 2

These can be deployed to FSW 6.0GA, they can be invoked in any order and all is well.  They return proper responses to the browser.

Deploy the same applications to Roll up 3, we see that invoking application 2 gets an Exception on invocation.  (Null Pointer at at org.switchyard.component.resteasy.InboundHandler.invoke(InboundHandler.java:129) [switchyard-component-resteasy-1.1.1-p8-redhat-1.jar:1.1.1-p8-redhat-1]

If we deploy application 2 after app 1, then app 2 is ok but 1 is broken.  

Deploy app 1 again, then 1 is ok and 2 is broken.  Last application deployed 'wins', the other loses.

Comment 1 Rick Wagner 2015-03-02 21:26:27 UTC
Created attachment 997241 [details]
Test App 1.

Comment 2 Rick Wagner 2015-03-02 21:27:10 UTC
Created attachment 997244 [details]
Test App 2.

Comment 3 Magesh Kumar Bojan 2015-03-05 04:46:52 UTC
This is an inherent problem with any web container. You cannot share the same context path between applications.

Comment 4 Tadayoshi Sato 2015-03-05 04:55:19 UTC
Hi Magesh,

I understand your point, but please note that you CAN indeed share the same context path between applications in FSW 6.0. So the current behaviour may be regarded as a correct one, but it still introduces an incompatibility from the old version.

We think it's ideal to keep backward compatibility as much as possible.

Comment 7 Magesh Kumar Bojan 2015-03-07 06:44:08 UTC
You are right. It worked in FSW 6.0. I have narrowed down the commit to this:

https://issues.jboss.org/browse/SWITCHYARD-2124

This looks like it doesn't cater to the domain. I am yet to verify if this is removed if it would break https://bugzilla.redhat.com/show_bug.cgi?id=1094865. Since SWITCHYARD-2351 covers most other things in camel, have to check if all the BZs associated with 1094865 is covered. If not 2124 needs some rework. Will update soon.

Comment 8 Magesh Kumar Bojan 2015-03-09 04:46:36 UTC
I confirmed that the replicator attached here works.

http://post-office.corp.redhat.com/archives/jboss-support-esb-list/2014-February/msg00023.html

I will send a PR removing the 2124 commits. Please let me know if any more issues after removing the commits.


Note You need to log in before you can comment on or make changes to this bug.